#ifndef FLASHPROGRESS_H
#define FLASHPROGRESS_H

#include <QDialog>

namespace Ui {
class flashprogress;
}

class flashprogress : public QWidget {
  Q_OBJECT

public:
  explicit flashprogress(QWidget *parent = 0);
  ~flashprogress();
  Ui::flashprogress *ui;
  void append_log(QString msg);
  void append_error(QString msg);
  void clear_log();
  void cancel_enable(bool value);
  bool is_cancelled();
  int set_eside_slider(int value);
  int set_tside_slider(int value);
  void append_divider(QString msg);
  void set_flash_speed(float bps);
  void reset_interface();
public slots:
  void recieve_message(QString msg);
  void recieve_divider(QString msg);
  void recieve_error_message(QString msg);
  void error_occurred();
  void recieve_cancel_enable(bool enable);
  void recieve_tside_progress(int value);
  void recieve_eside_progress(int value);
  void recieve_flash_speed(float value);
signals:
  void click_cancel_button();
private:
  int n_errors;
  bool cancelled;
  void closeEvent(QCloseEvent *x);
  float flash_speed_avg;
  int flash_speed_count;
private slots:
  void on_cancel_btn_clicked();

};

#endif // FLASHPROGRESS_H
